<script setup lang="ts">
    import { ServiceOffer } from '@/serviceOffer/entities/serviceOffer/ServiceOffer'
    import { isDefined } from '@/shared/helpers/types'
    import { ref } from 'vue'

    const name = 'ServiceOfferComponent'
    const showDescription = ref(false)

    interface Props {
        serviceOffer: ServiceOffer
    }

    defineProps<Props>()
</script>

<template>
    <v-hover v-slot="{ isHovering }">
        <v-card
            :data-cy="`component-${name}-${serviceOffer.id}`"
            class="overflow-hidden"
            :elevation="isHovering ? 8 : 1"
            style="position: relative"
            :to="serviceOffer.getItemRoute()"
        >
            <v-chip
                v-if="serviceOffer.environnement != 'PROD'"
                :color="serviceOffer.getEnvironnementColor()"
                variant="flat"
                label
                class="environnement-chip"
                ><v-icon :icon="serviceOffer.getEnvironnementIcon()"></v-icon>
                <p>
                    {{ serviceOffer.environnement }}
                </p></v-chip
            >
            <v-img
                :src="serviceOffer.image"
                :alt="serviceOffer.title"
                cover
                height="170"
            >
            </v-img>

            <v-card-title class="card-title text-subtitle-1">
                <span class="card-title__text">{{ serviceOffer.title }}</span>
                <v-btn
                    v-if="
                        isDefined(serviceOffer.description) &&
                        serviceOffer.description != ''
                    "
                    color="secondary-info"
                    variant="plain"
                    class="card-title__button"
                    size="medium"
                    @click.prevent="showDescription = !showDescription"
                >
                    <v-icon
                        :icon="
                            showDescription
                                ? 'mdi-close-circle-outline'
                                : 'mdi-information-outline'
                        "
                        size="large"
                    />
                    <v-tooltip
                        v-model="showDescription"
                        :text="serviceOffer.description"
                        max-width="400px"
                        activator="parent"
                        location="top"
                    />
                </v-btn>
            </v-card-title>
        </v-card>
    </v-hover>
</template>

<style scoped lang="scss">
    .environnement-chip {
        position: absolute;
        cursor: pointer;
        z-index: 10;
        right: 5px;
        top: 5px;

        @media (min-width: 767px) {
            p {
                display: none;
            }

            :hover {
                p {
                    margin-left: 5px;
                    display: block;
                }
            }
        }
    }

    .card-title {
        display: flex;
        justify-content: space-between;

        &__text {
            overflow: hidden;
            text-overflow: ellipsis;
        }

        &__button {
            padding: 10px;
            margin: -10px;
        }
    }
</style>
